package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.DEDataChgDisp;
import com.sa.ibiz.demo.demo.service.DEDataChgDispService;
import com.sa.ibiz.demo.demo.service.dto.DEDataChgDispSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/dedatachgdisp")
public class DEDataChgDispResource
{
	@Autowired
	private DEDataChgDispService service;


	@PostMapping(value = "/getDraft")
	public ResponseEntity<DEDataChgDisp> getDraft(@Validated @RequestBody DEDataChgDisp data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("实体数据变更派发引擎[getDraft]操作发生错误","DEDataChgDisp","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<DEDataChgDisp> checkKey(@Validated @RequestBody DEDataChgDisp data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("实体数据变更派发引擎[checkKey]操作发生错误","DEDataChgDisp",data.getDedatachgdispid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<DEDataChgDisp> update(@Validated @RequestBody DEDataChgDisp data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("实体数据变更派发引擎[update]操作发生错误","DEDataChgDisp",data.getDedatachgdispid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<DEDataChgDisp> remove(@Validated @RequestBody DEDataChgDisp data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("实体数据变更派发引擎[remove]操作发生错误","DEDataChgDisp",data.getDedatachgdispid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<DEDataChgDisp> create(@Validated @RequestBody DEDataChgDisp data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("实体数据变更派发引擎[create]操作发生错误","DEDataChgDisp",data.getDedatachgdispid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<DEDataChgDisp> get(@Validated @PathVariable String id){
		DEDataChgDisp data=new DEDataChgDisp();
		data.setDedatachgdispid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("实体数据变更派发引擎[get]操作发生错误","DEDataChgDisp",id.toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<DEDataChgDisp>> searchDefaultPage(@Validated @RequestBody DEDataChgDispSearchFilter filter){
		Page<DEDataChgDisp> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<DEDataChgDisp>> listDefault(@Validated @RequestBody DEDataChgDispSearchFilter filter){
		List<DEDataChgDisp> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
